{{ keyer_obj_b.spin 

Morse Iambic keyer  Mode B

Two cogs run, one each watching for dits and dahs from an operator paddle. (Key)
The lock hold off the next dit or dah, making the iambic operation very simple on the Propeller.

The pins are set for use on the propeller demo board.

Pull up resisters required for the dit and dah pins.

This demo drives an LED with the ppt_pin.

To key an actual transmitter, a transister switch would be driven by the ppt_pin.

Program by Doug Wheeland, W0KIT
2007

}}

VAR
  long index
  long dit_stk[10]
  long dah_stk[10]
  long dit_period     ' dit period
  long space_period   ' inter element period
  long dah_period     ' dah period
  byte dd_sem4        
  byte dit_cog
  byte dah_cog
  
CON
'  _clkmode          = xtal1 + pll16x
'  _xinfreq          = 5_000_000
  dit_pin           = 0
  dah_pin           = 1
  side_tone_pin     = 10
  ptt_pin           = 16
  one_mic_sec       = 80
  tone_freq         = 70_000
  
pub start(sem4)
   dd_sem4 := sem4

pub set_dah_period(percent)
'set the dah element period to a percentage of the element period. 200 - 400
    percent #>= 200
    percent <#= 400
    dah_period := dit_period * percent / 100

pub set_space_period(percent)
'set the inter-element period to a percentage of the element period.  25 - 150
    percent #>= 25
    percent <#= 150
    space_period := dit_period * percent / 100
    
pub set_dit_period(mic_sec)
'set the basic element period. 50_000 -  200_000 micro seconds
    mic_sec #>= 20_000
    mic_sec <#= 200_000
    dit_period := mic_sec

pub start_keyer_mode_b
'init and start the dit and dah cogs
    dit_cog := cognew(dit_drv_b(dd_sem4), @dit_stk)
    dah_cog := cognew(dah_drv_b(dd_sem4), @dah_stk)
    
pub stop_keyer
' stop the dit and dah cogs
    if dit_cog > 0
      cogstop(dit_cog)
    if dah_cog > 0
      cogstop(dah_cog)

pri dit_drv_b(sem4)
' This code runs in a cog watching for dits (MODE B)
    dira[ptt_pin]~~
    dira[side_tone_pin]~~
    dira[dit_pin]~
    repeat
      frqa := tone_freq
      if ina[dit_pin] == false
        waitcnt(1000 * one_mic_sec + cnt)
        if ina[dit_pin] == false
          repeat until not lockset(sem4)
          ctra := %00100_000 << 23 + side_tone_pin
          outa[ptt_pin]~~
          waitcnt(dit_period * one_mic_sec + cnt)
          outa[ptt_pin]~
          ctra := 0
          waitcnt(space_period * one_mic_sec + cnt)
          lockclr(sem4)
 
pri dah_drv_b(sem4)
' This code runs in a cog watching for dahs (MODE B)
    dira[ptt_pin]~~
    dira[side_tone_pin]~~
    dira[dit_pin]~
    repeat
      frqa := tone_freq
      if ina[dah_pin] == false
        waitcnt(1000 * one_mic_sec + cnt)
        if ina[dah_pin] == false
          repeat until not lockset(sem4)
          ctra := %00100_000 << 23 + side_tone_pin
          outa[ptt_pin]~~
          waitcnt(dah_period * one_mic_sec + cnt)
          outa[ptt_pin]~
          ctra := 0
          waitcnt(space_period * one_mic_sec + cnt)
          lockclr(sem4)
          
      